%% (c) 2017 CERTH-ITI, Visual Computing Lab
%% This code is licensed under MIT license (see LICENSE.txt for details)

clear; clc;

%%uncomment the line below and insert path of the set e.g. 'C:\Documents\train'
%%PATH = 'C:\insert\path\to\set';
tempTruth1 = importdata('train_id.txt');
tempTruth2 = importdata('validation_id.txt');
tempTruth3 = importdata('test_id.txt');
[tr1_x, tr1_y] = size(tempTruth1.textdata);
[tr2_x, tr2_y] = size(tempTruth2.textdata);
[tr3_x, tr3_y] = size(tempTruth3.textdata);
kinect = 0;
%set up environment for 3D mesh
xx = (424:-1:1); yy = (512:-1:1);

for i=1:length(dir(PATH))
    ktemp = dir(PATH);
    ktemp = {ktemp([ktemp.isdir]).name};
end

[xtemp, ytemp] = size(ktemp);

for subjectFolder = 3:ytemp
    Subj = ktemp{1,subjectFolder};
    %Choose Kinect: D2 = 1, D4 = 2, D8 = 3
    for truthIter = 1:tr1_x
        boolTruth = strcmp(Subj,tempTruth1.textdata(truthIter));
        if boolTruth ~= 0
            kinect = tempTruth1.data(truthIter);
        end
    end
    for truthIter = 1:tr2_x
        boolTruth = strcmp(Subj,tempTruth2.textdata(truthIter));
        if boolTruth ~= 0
            kinect = tempTruth2.data(truthIter);
        end
    end
    for truthIter = 1:tr3_x
        boolTruth = strcmp(Subj,tempTruth3.textdata(truthIter));
        if boolTruth ~= 0
            kinect = tempTruth3.data(truthIter);
        end
    end
    if (kinect == 1)
        %D2
        RT = [1063.25378 -5.87225 961.79668 56231.24552; -5.71647 -1063.35374 579.27006 -0.06444; 0.00000 0.00000 1.00000 0.00000; 0.0 0.0 0.0 1.0];
        R = [0.99999 -0.00545 -0.00000; -0.00545 -0.99999 0.00000; 0.00000 0.00000 1.00000];
        T = [52.88520 -0.00006 0.00000];
        fx_d = 366.6209;
        fy_d = -366.6209;
        cx_d = 258.0533;
        cy_d = 211.3541;
        fx_rgb = 1063.27000;
        fy_rgb = -1063.36911;
        cx_rgb = 961.79668;
        cy_rgb = 579.27006;
        fileID = fopen('D2_worldMap.txt');
    elseif(kinect == 2)
        %D4
        RT = [1066.06360 -7.42921 961.62091 56231.29035; -6.87077 -1065.97854 535.42505 -0.05257; 0.00000 -0.00000 1.00000 0.00000; 0.0 0.0 0.0 1.0];
        R = [0.99998 -0.00671 -0.00000; -0.00671 -0.99998 -0.00000; 0.00000 -0.00000 1.00000];
        T = [52.74538 -0.00005 0.00000];
        fx_d = 366.7136;
        fy_d = -366.7136;
        cx_d = 256.5948;
        cy_d = 207.1343;
        fx_rgb = 1066.08949;
        fy_rgb = -1066.00068;
        cx_rgb = 961.62091;
        cy_rgb = 535.42505;
        fileID = fopen('D4_worldMap.txt');
    else
        %D8
        R = [0.99991 -0.01331 0.00000; -0.01331 -0.99991 -0.00000; -0.00000 -0.00000 1.00000];
        T = [52.80262 0.00001 0.00000];
        fx_d = 366.7687;
        fy_d = -366.7687;
        cx_d = 259.6398;
        cy_d = 206.6859;
        fx_rgb = 1064.93312;
        fy_rgb = -1065.04812;
        cx_rgb = 967.89667;
        cy_rgb = 535.47275;
        fileID = fopen('D8_worldMap.txt');
    end
    
    D = textscan(fileID, '%f %f', 'delimiter',' '';');
    worldMap_x = zeros(512,424);
    worldMap_y = zeros(512,424);
    
    iter = 0;
    for j = 1:424
        for i = 1:512
            worldMap_x(i,j) = D{1,1}((iter*512)+i);
            worldMap_y(i,j) = D{1,2}((iter*512)+i);
        end
        iter = iter+1;
    end
    
    worldMap_x = worldMap_x';
    worldMap_y = worldMap_y';
    
    subjectPath = horzcat(PATH,filesep,Subj);
    mkdir(PATH, Subj)
    savePath = horzcat(PATH,filesep,Subj);
    for i=1:length(dir(subjectPath))
        k3 = dir(subjectPath);
        k3 = {k3([k3.isdir]).name};
    end
    [x_k3, y_k3]=size(k3);
    for actionFolder = 3:y_k3
        rgbPath = horzcat(subjectPath,filesep,k3{1,actionFolder});
        rgbPath = horzcat(rgbPath,filesep,'rgb');
        depthPath = horzcat(subjectPath,filesep,k3{1,actionFolder});
        depthPath = horzcat(depthPath,filesep,'depth');
        
        for i=1:length(dir(fullfile(rgbPath,'*.png')))
            k1 = dir(fullfile(rgbPath,'*.png'));
            k1 = {k1(~[k1.isdir]).name};
        end
        for i=1:length(dir(fullfile(depthPath,'*.png')))
            k2 = dir(fullfile(depthPath,'*.png'));
            k2 = {k2(~[k2.isdir]).name};
        end        
        [k_w, k_h] = size(k1);

        %prepare directories to save png
        %RGB
        mkdir(savePath, k3{1,actionFolder});
        saveFlow = horzcat(savePath,filesep,k3{1,actionFolder});
        mkdir(saveFlow, 'rgb_aligned');
        tempPath = horzcat(saveFlow,filesep,'rgb_aligned');
        %Depth
        mkdir(saveFlow, 'depth_aligned');
        tempPathDepth = horzcat(saveFlow,filesep,'depth_aligned');
        
        for fileIter = 1:k_h
            flowRGB = horzcat(rgbPath,filesep,k1{1,fileIter});
            flowDepth = horzcat(depthPath,filesep,k2{1,fileIter});
            DEPTH = imread(flowDepth);
            DEPTH = double(DEPTH);
            [w_d, h_d] = size(DEPTH);
            I = zeros(424, 512, 3);
            II = zeros(424, 512,1);
            for i=1:424
                for j=1:512
                    II(i,j,1) = 0;
                end
            end
            RGB = imread(flowRGB);
            pixVal = zeros(424,512);
            map_2D = zeros(512*424,2);
            if(kinect == 1)
                for i=1:w_d
                    for j=1:h_d
                        pixelVal = DEPTH(i,j);
                        x_depth = worldMap_x(i,j)*pixelVal;
                        y_depth = worldMap_y(i,j)*pixelVal;
                        if((pixelVal < 1700) && (pixelVal > 800) && (y_depth > -140) && (x_depth > -270) && (x_depth < 270))
                            pixVal(i,j) = pixelVal;
                            
                            %calculate x_rgb, y_rgb
                            P3D(1) = (j - cx_d) * pixelVal / fx_d;
                            P3D(2) = (i - cy_d) * pixelVal / fy_d;
                            P3D(3) = pixelVal;
                            new_P3D = R*P3D' + T';
                            P2D_rgb(1) = ((new_P3D(1) * fx_rgb)/ new_P3D(3)) + cx_rgb;
                            P2D_rgb(2) = ((new_P3D(2) * -fy_rgb)/ new_P3D(3)) + cy_rgb;
                            
                            %thresholding
                            if(P2D_rgb(1)>=1 && P2D_rgb(2)>=1 && P2D_rgb(2)<=1080)
                                
                                %map color from RGB to corresponding Depth pixel
                                I(i,j,1) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),1))/255;
                                I(i,j,2) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),2))/255;
                                I(i,j,3) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),3))/255;
                                II(i,j) = DEPTH(i,j);
                            end
                        end
                    end
                end
            elseif(kinect == 2)
                for i=1:w_d
                    for j=1:h_d
                        pixelVal = DEPTH(i,j);
                        x_depth = worldMap_x(i,j)*pixelVal;
                        y_depth = worldMap_y(i,j)*pixelVal;
                        if((pixelVal < 1180) && (pixelVal > 690) && (y_depth > -180) && (x_depth > -380) && (x_depth < 480))
                            if((pixelVal < 1180) && (pixelVal > 700) && (y_depth > -180) && (x_depth > -270) && (x_depth < 460))
                                pixVal(i,j) = pixelVal;
                                
                                %calculate x_rgb, y_rgb
                                P3D(1) = (j - cx_d) * pixelVal / fx_d;
                                P3D(2) = (i - cy_d) * pixelVal / fy_d;
                                P3D(3) = pixelVal;
                                new_P3D = R*P3D' + T';
                                P2D_rgb(1) = ((new_P3D(1) * fx_rgb)/ new_P3D(3)) + cx_rgb;
                                P2D_rgb(2) = ((new_P3D(2) * -fy_rgb)/ new_P3D(3)) + cy_rgb;
                                
                                %thresholding
                                if(P2D_rgb(1)>=1 && P2D_rgb(2)>=1 && P2D_rgb(2)<=1080)
                                    
                                    %map color from RGB to corresponding Depth pixel
                                    I(i,j,1) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),1))/255;
                                    I(i,j,2) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),2))/255;
                                    I(i,j,3) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),3))/255;
                                    II(i,j) = DEPTH(i,j);
                                end
                            end
                        end
                    end
                end
            else
                for i=1:w_d
                    for j=1:h_d
                        pixelVal = DEPTH(i,j);
                        x_depth = worldMap_x(i,j)*pixelVal;
                        y_depth = worldMap_y(i,j)*pixelVal;
                        if((pixelVal < 1700) && (pixelVal > 560) && (y_depth > -120) && (x_depth > -400) && (x_depth < 450))
                            if((y_depth > 120) && (x_depth > 50) && (x_depth < 460) && pixelVal > 1080)
                                I(i,j,1) = 0;
                            else
                                if((pixelVal < 1700) && (pixelVal > 800) && (y_depth > -150) && (x_depth > -270) && (x_depth < 450))
                                    pixVal(i,j) = pixelVal;
                                    
                                    %calculate x_rgb, y_rgb
                                    P3D(1) = (j - cx_d) * pixelVal / fx_d;
                                    P3D(2) = (i - cy_d) * pixelVal / fy_d;
                                    P3D(3) = pixelVal;
                                    new_P3D = R*P3D' + T';
                                    P2D_rgb(1) = ((new_P3D(1) * fx_rgb)/ new_P3D(3)) + cx_rgb;
                                    P2D_rgb(2) = ((new_P3D(2) * -fy_rgb)/ new_P3D(3)) + cy_rgb;
                                    
                                    %thresholding
                                    if(P2D_rgb(1)>=1 && P2D_rgb(2)>=1 && P2D_rgb(2)<=1080)
                                        
                                        %map color from RGB to corresponding Depth pixel
                                        I(i,j,1) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),1))/255;
                                        I(i,j,2) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),2))/255;
                                        I(i,j,3) = double(RGB(round(P2D_rgb(2)), round(P2D_rgb(1)),3))/255;
                                        II(i,j) = DEPTH(i,j);
                                    end
                                end
                            end
                        end
                    end
                end
            end   
            B(:,:,1) = medfilt2(I(:,:,1), [3 3], 'zeros');
            B(:,:,2) = medfilt2(I(:,:,2), [3 3], 'zeros');
            B(:,:,3) = medfilt2(I(:,:,3), [3 3], 'zeros');
            RGBsavePath = horzcat(tempPath,filesep,k1{1,fileIter});
            imwrite(B,RGBsavePath);
            DepthsavePath = horzcat(tempPathDepth,filesep,k2{1,fileIter});
            imwrite(uint16(II),DepthsavePath);
        end
    end
end